<?php

namespace Jet_FB_HubSpot;


use Jet_FB_HubSpot\JetEngine\Tabs\ManagerTabs as JEManagerTabs;
use Jet_FB_HubSpot\JetFormBuilder\Tabs\ManagerTabs as JFBManagerTabs;
use Jet_FB_HubSpot\JetEngine\Notifications\Manager as JEActionManager;
use Jet_FB_HubSpot\JetFormBuilder\Actions\Manager as JFBActionManager;
use Jet_FB_HubSpot\JetFormBuilder\OAuth\Handler as JFBHandler;
use Jet_FB_HubSpot\JetEngine\OAuth\Handler as JEHandler;

if ( ! defined( 'WPINC' ) ) {
	die();
}

class Plugin {
	/**
	 * Instance.
	 *
	 * Holds the plugin instance.
	 *
	 * @since 1.0.0
	 * @access public
	 * @static
	 *
	 * @var Plugin
	 */
	public static $instance = null;

	public $slug = 'jet-form-builder-hubspot-action';

	public function __construct() {
		JEManagerTabs::register();
		JFBManagerTabs::register();

		JFBActionManager::register();
		JEActionManager::register();

		Handler::instance();

		JFBHandler::instance()->handle_request();
		JEHandler::instance()->handle_request();

		$can_init_license = (
			is_admin()
			&& function_exists( 'jet_form_builder' )
			&& array_key_exists( 'addons_manager', get_object_vars( jet_form_builder() ) )
		);

		if ( $can_init_license ) {
			require $this->plugin_dir( 'includes/class-jfb-license-manager.php' );

			new \JFB_License_Manager();
		}
	}

	public function get_version() {
		return JET_FB_HUBSPOT_ACTION_VERSION;
	}

	public function plugin_url( $path ) {
		return JET_FB_HUBSPOT_ACTION_URL . $path;
	}

	public function plugin_dir( $path = '' ) {
		return JET_FB_HUBSPOT_ACTION_PATH . $path;
	}

	public function get_template_path( $template ) {
		$path = JET_FB_HUBSPOT_ACTION_PATH . 'templates' . DIRECTORY_SEPARATOR;

		return ( $path . $template . '.php' );
	}


	/**
	 * Instance.
	 *
	 * Ensures only one instance of the plugin class is loaded or can be loaded.
	 *
	 * @return Plugin An instance of the class.
	 * @since 1.0.0
	 * @access public
	 * @static
	 *
	 */
	public static function instance() {
		if ( is_null( self::$instance ) ) {
			self::$instance = new self();
		}

		return self::$instance;
	}

}

Plugin::instance();