<?php
/**
 * ConditionalSingleFieldDependency
 *
 * PHP version 5
 *
 * @category Class
 * @package  HubSpot\Client\Automation\Actions
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Custom Workflow Actions
 *
 * Create custom workflow actions
 *
 * The version of the OpenAPI document: v4
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace HubSpot\Client\Automation\Actions\Model;

use \ArrayAccess;
use \HubSpot\Client\Automation\Actions\ObjectSerializer;

/**
 * ConditionalSingleFieldDependency Class Doc Comment
 *
 * @category Class
 * @package  HubSpot\Client\Automation\Actions
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class ConditionalSingleFieldDependency implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'ConditionalSingleFieldDependency';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'dependency_type' => 'string',
        'dependent_field_names' => 'string[]',
        'controlling_field_name' => 'string',
        'controlling_field_value' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'dependency_type' => null,
        'dependent_field_names' => null,
        'controlling_field_name' => null,
        'controlling_field_value' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'dependency_type' => 'dependencyType',
        'dependent_field_names' => 'dependentFieldNames',
        'controlling_field_name' => 'controllingFieldName',
        'controlling_field_value' => 'controllingFieldValue'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'dependency_type' => 'setDependencyType',
        'dependent_field_names' => 'setDependentFieldNames',
        'controlling_field_name' => 'setControllingFieldName',
        'controlling_field_value' => 'setControllingFieldValue'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'dependency_type' => 'getDependencyType',
        'dependent_field_names' => 'getDependentFieldNames',
        'controlling_field_name' => 'getControllingFieldName',
        'controlling_field_value' => 'getControllingFieldValue'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    const DEPENDENCY_TYPE_CONDITIONAL_SINGLE_FIELD = 'CONDITIONAL_SINGLE_FIELD';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getDependencyTypeAllowableValues()
    {
        return [
            self::DEPENDENCY_TYPE_CONDITIONAL_SINGLE_FIELD,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['dependency_type'] = isset($data['dependency_type']) ? $data['dependency_type'] : 'CONDITIONAL_SINGLE_FIELD';
        $this->container['dependent_field_names'] = isset($data['dependent_field_names']) ? $data['dependent_field_names'] : null;
        $this->container['controlling_field_name'] = isset($data['controlling_field_name']) ? $data['controlling_field_name'] : null;
        $this->container['controlling_field_value'] = isset($data['controlling_field_value']) ? $data['controlling_field_value'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['dependency_type'] === null) {
            $invalidProperties[] = "'dependency_type' can't be null";
        }
        $allowedValues = $this->getDependencyTypeAllowableValues();
        if (!is_null($this->container['dependency_type']) && !in_array($this->container['dependency_type'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'dependency_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if ($this->container['dependent_field_names'] === null) {
            $invalidProperties[] = "'dependent_field_names' can't be null";
        }
        if ($this->container['controlling_field_name'] === null) {
            $invalidProperties[] = "'controlling_field_name' can't be null";
        }
        if ($this->container['controlling_field_value'] === null) {
            $invalidProperties[] = "'controlling_field_value' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets dependency_type
     *
     * @return string
     */
    public function getDependencyType()
    {
        return $this->container['dependency_type'];
    }

    /**
     * Sets dependency_type
     *
     * @param string $dependency_type dependency_type
     *
     * @return $this
     */
    public function setDependencyType($dependency_type)
    {
        $allowedValues = $this->getDependencyTypeAllowableValues();
        if (!in_array($dependency_type, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'dependency_type', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['dependency_type'] = $dependency_type;

        return $this;
    }

    /**
     * Gets dependent_field_names
     *
     * @return string[]
     */
    public function getDependentFieldNames()
    {
        return $this->container['dependent_field_names'];
    }

    /**
     * Sets dependent_field_names
     *
     * @param string[] $dependent_field_names dependent_field_names
     *
     * @return $this
     */
    public function setDependentFieldNames($dependent_field_names)
    {
        $this->container['dependent_field_names'] = $dependent_field_names;

        return $this;
    }

    /**
     * Gets controlling_field_name
     *
     * @return string
     */
    public function getControllingFieldName()
    {
        return $this->container['controlling_field_name'];
    }

    /**
     * Sets controlling_field_name
     *
     * @param string $controlling_field_name controlling_field_name
     *
     * @return $this
     */
    public function setControllingFieldName($controlling_field_name)
    {
        $this->container['controlling_field_name'] = $controlling_field_name;

        return $this;
    }

    /**
     * Gets controlling_field_value
     *
     * @return string
     */
    public function getControllingFieldValue()
    {
        return $this->container['controlling_field_value'];
    }

    /**
     * Sets controlling_field_value
     *
     * @param string $controlling_field_value controlling_field_value
     *
     * @return $this
     */
    public function setControllingFieldValue($controlling_field_value)
    {
        $this->container['controlling_field_value'] = $controlling_field_value;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


