<?php
/**
 * ImportResult
 *
 * PHP version 5
 *
 * @category Class
 * @package  HubSpot\Client\Cms\Hubdb
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * HubDB endpoints
 *
 * HubDB is a relational data store that presents data as rows, columns, and cells in a table, much like a spreadsheet. HubDB tables can be added or modified [in the HubSpot CMS](https://knowledge.hubspot.com/cos-general/how-to-edit-hubdb-tables), but you can also use the API endpoints documented here. For more information on HubDB tables and using their data on a HubSpot site, see the [CMS developers site](https://designers.hubspot.com/docs/tools/hubdb). You can also see the [documentation for dynamic pages](https://designers.hubspot.com/docs/tutorials/how-to-build-dynamic-pages-with-hubdb) for more details about the `useForPages` field.  HubDB tables support `draft` and `live` versions and you can publish and unpublish the live version. This allows you to update data in the table, either for testing or to allow for a manual approval process, without affecting any live pages using the existing data. Draft data can be reviewed, pushed to live version, and published by a user working in HubSpot or published via the API. Draft data can also be discarded, allowing users to go back to the live version of the data without disrupting it. If a table is set to be `allowed for public access`, you can access the published version of the table and rows without any authentication by specifying the portal id via the query parameter `portalId`.
 *
 * The version of the OpenAPI document: v3
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace HubSpot\Client\Cms\Hubdb\Model;

use \ArrayAccess;
use \HubSpot\Client\Cms\Hubdb\ObjectSerializer;

/**
 * ImportResult Class Doc Comment
 *
 * @category Class
 * @description The result of import operation
 * @package  HubSpot\Client\Cms\Hubdb
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class ImportResult implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'ImportResult';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'errors' => '\HubSpot\Client\Cms\Hubdb\Model\Error[]',
        'rows_imported' => 'int',
        'duplicate_rows' => 'int',
        'row_limit_exceeded' => 'bool'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'errors' => null,
        'rows_imported' => 'int32',
        'duplicate_rows' => 'int32',
        'row_limit_exceeded' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'errors' => 'errors',
        'rows_imported' => 'rowsImported',
        'duplicate_rows' => 'duplicateRows',
        'row_limit_exceeded' => 'rowLimitExceeded'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'errors' => 'setErrors',
        'rows_imported' => 'setRowsImported',
        'duplicate_rows' => 'setDuplicateRows',
        'row_limit_exceeded' => 'setRowLimitExceeded'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'errors' => 'getErrors',
        'rows_imported' => 'getRowsImported',
        'duplicate_rows' => 'getDuplicateRows',
        'row_limit_exceeded' => 'getRowLimitExceeded'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['errors'] = isset($data['errors']) ? $data['errors'] : null;
        $this->container['rows_imported'] = isset($data['rows_imported']) ? $data['rows_imported'] : null;
        $this->container['duplicate_rows'] = isset($data['duplicate_rows']) ? $data['duplicate_rows'] : null;
        $this->container['row_limit_exceeded'] = isset($data['row_limit_exceeded']) ? $data['row_limit_exceeded'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['errors'] === null) {
            $invalidProperties[] = "'errors' can't be null";
        }
        if ($this->container['rows_imported'] === null) {
            $invalidProperties[] = "'rows_imported' can't be null";
        }
        if ($this->container['duplicate_rows'] === null) {
            $invalidProperties[] = "'duplicate_rows' can't be null";
        }
        if ($this->container['row_limit_exceeded'] === null) {
            $invalidProperties[] = "'row_limit_exceeded' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets errors
     *
     * @return \HubSpot\Client\Cms\Hubdb\Model\Error[]
     */
    public function getErrors()
    {
        return $this->container['errors'];
    }

    /**
     * Sets errors
     *
     * @param \HubSpot\Client\Cms\Hubdb\Model\Error[] $errors List of errors during import
     *
     * @return $this
     */
    public function setErrors($errors)
    {
        $this->container['errors'] = $errors;

        return $this;
    }

    /**
     * Gets rows_imported
     *
     * @return int
     */
    public function getRowsImported()
    {
        return $this->container['rows_imported'];
    }

    /**
     * Sets rows_imported
     *
     * @param int $rows_imported Specifies number of rows imported
     *
     * @return $this
     */
    public function setRowsImported($rows_imported)
    {
        $this->container['rows_imported'] = $rows_imported;

        return $this;
    }

    /**
     * Gets duplicate_rows
     *
     * @return int
     */
    public function getDuplicateRows()
    {
        return $this->container['duplicate_rows'];
    }

    /**
     * Sets duplicate_rows
     *
     * @param int $duplicate_rows Specifies number of duplicate rows
     *
     * @return $this
     */
    public function setDuplicateRows($duplicate_rows)
    {
        $this->container['duplicate_rows'] = $duplicate_rows;

        return $this;
    }

    /**
     * Gets row_limit_exceeded
     *
     * @return bool
     */
    public function getRowLimitExceeded()
    {
        return $this->container['row_limit_exceeded'];
    }

    /**
     * Sets row_limit_exceeded
     *
     * @param bool $row_limit_exceeded Specifies whether row limit exceeded during import
     *
     * @return $this
     */
    public function setRowLimitExceeded($row_limit_exceeded)
    {
        $this->container['row_limit_exceeded'] = $row_limit_exceeded;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


