<?php

namespace Jet_FB_Limit_Form_Responses;


if ( ! defined( 'WPINC' ) ) {
	die();
}

class Plugin {
	/**
	 * Instance.
	 *
	 * Holds the plugin instance.
	 *
	 * @since 1.0.0
	 * @access public
	 * @static
	 *
	 * @var Plugin
	 */
	public static $instance = null;

	public $slug = 'jet-form-builder-limit-form-responses';

	public function __construct() {
		add_action( 'after_setup_theme', array( $this, 'init_components' ), -9999 );
	}

	public function init_components() {
		LimitResponses::instance();

		JetEngine\MetaBox::register();
		JetEngine\PreventSubmit::register();
		new JetEngine\PreventRender();

		JetFormBuilder\LimitPluginManager::register();
		JetFormBuilder\PreventSubmit::register();
		new JetFormBuilder\PreventRender();

		new ElementorStyleManager();
		new GutenbergStyleManager();

		$can_init_license = (
			is_admin()
			&& function_exists( 'jet_form_builder' )
			&& array_key_exists( 'addons_manager', get_object_vars( jet_form_builder() ) )
		);

		if ( $can_init_license ) {
			require $this->plugin_dir( 'includes/class-jfb-license-manager.php' );

			new \JFB_License_Manager();
		}
	}

	public function get_version() {
		return JET_FB_LIMIT_FORM_RESPONSES_VERSION;
	}

	public function plugin_url( $path ) {
		return JET_FB_LIMIT_FORM_RESPONSES_URL . $path;
	}

	public function plugin_dir( $path = '' ) {
		return JET_FB_LIMIT_FORM_RESPONSES_PATH . $path;
	}

	public function get_template_path( $template ) {
		$path = JET_FB_LIMIT_FORM_RESPONSES_PATH . 'templates' . DIRECTORY_SEPARATOR;

		return ( $path . $template . '.php' );
	}


	/**
	 * Instance.
	 *
	 * Ensures only one instance of the plugin class is loaded or can be loaded.
	 *
	 * @return Plugin An instance of the class.
	 * @since 1.0.0
	 * @access public
	 * @static
	 *
	 */
	public static function instance() {
		if ( is_null( self::$instance ) ) {
			self::$instance = new self();
		}

		return self::$instance;
	}

}

Plugin::instance();