<?php
/**
 * Plugin Name: JetFormBuilder Limit Form Responses
 * Plugin URI:  https://jetformbuilder.com/addons/limit-form-responses/
 * Description: A lightweight addon to control the overall number of form submissions and those per user.
 * Version:     1.0.3
 * Author:      Crocoblock
 * Author URI:  https://crocoblock.com/
 * Text Domain: jet-form-builder-limit-form-responses
 * License:     GPL-3.0+
 * License URI: http://www.gnu.org/licenses/gpl-3.0.txt
 * Domain Path: /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die();
}

define( 'JET_FB_LIMIT_FORM_RESPONSES_VERSION', '1.0.3' );

define( 'JET_FB_LIMIT_FORM_RESPONSES__FILE__', __FILE__ );
define( 'JET_FB_LIMIT_FORM_RESPONSES_PLUGIN_BASE', plugin_basename( __FILE__ ) );
define( 'JET_FB_LIMIT_FORM_RESPONSES_PATH', plugin_dir_path( __FILE__ ) );
define( 'JET_FB_LIMIT_FORM_RESPONSES_URL', plugins_url( '/', __FILE__ ) );

require JET_FB_LIMIT_FORM_RESPONSES_PATH . 'vendor/autoload.php';

add_action( 'plugins_loaded', function () {

	if ( ! version_compare( PHP_VERSION, '7.0.0', '>=' ) ) {
		add_action( 'admin_notices', function () {
			$class   = 'notice notice-error';
			$message = __(
				'<b>Error:</b> <b>JetFormBuilder Limit Form Responses</b> plugin requires a PHP version ">= 7.0"',
				'jet-form-builder-limit-form-responses'
			);
			printf( '<div class="%1$s"><p>%2$s</p></div>', esc_attr( $class ), wp_kses_post( $message ) );
		} );

		return;
	}
	require JET_FB_LIMIT_FORM_RESPONSES_PATH . 'includes/plugin.php';
}, 100 );

