<?php
/**
 * Plugin Name: JetFormBuilder Select Autocomplete
 * Plugin URI:  https://jetformbuilder.com/addons/select-autocomplete/
 * Description: A tweak to auto-fill the values dynamically in the Select field type.
 * Version:     1.0.3
 * Author:      Crocoblock
 * Author URI:  https://crocoblock.com/
 * Text Domain: jet-form-builder-select-autocomplete
 * License:     GPL-3.0+
 * License URI: http://www.gnu.org/licenses/gpl-3.0.txt
 * Domain Path: /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die();
}

add_action( 'plugins_loaded', function () {
	if ( ! version_compare( PHP_VERSION, '7.0.0', '>=' ) ) {
		add_action( 'admin_notices', function () {
			$class   = 'notice notice-error';
			$message = __(
				'<b>Error:</b> <b>JetFormBuilder Select Autocomplete</b> plugin requires a PHP version ">= 7.0"',
				'jet-form-builder-select-autocomplete'
			);
			printf( '<div class="%1$s"><p>%2$s</p></div>', esc_attr( $class ), wp_kses_post( $message ) );
		} );

		return;
	}

	define( 'JET_FB_SELECT_AUTOCOMPLETE_VERSION', '1.0.3' );

	define( 'JET_FB_SELECT_AUTOCOMPLETE__FILE__', __FILE__ );
	define( 'JET_FB_SELECT_AUTOCOMPLETE_PLUGIN_BASE', plugin_basename( __FILE__ ) );
	define( 'JET_FB_SELECT_AUTOCOMPLETE_PATH', plugin_dir_path( __FILE__ ) );
	define( 'JET_FB_SELECT_AUTOCOMPLETE_URL', plugins_url( '/', __FILE__ ) );

	require JET_FB_SELECT_AUTOCOMPLETE_PATH . 'vendor/autoload.php';
	require JET_FB_SELECT_AUTOCOMPLETE_PATH . 'includes/plugin.php';

}, 100 );

